import { Component } from '@angular/core';
import { NavController, AlertController } from 'ionic-angular';
import { DefaultListable } from '../../defaults/default-listable';
import { INavigable } from '../../interfaces/navigable-interface';
import { Product } from '../../models/product';
import { ProductDetailsPage } from '../product-details/product-details';
import { DataProvider } from '../../providers/data-provider'

@Component({
    selector: 'page-product-list',
    providers: [DataProvider],
    templateUrl: 'product-list.html'
})
export class ProductListPage extends DefaultListable<Product> implements INavigable {

    constructor(
        public navCtrl: NavController,
        public data: DataProvider,
        public alertCtrl: AlertController
    ){
        super();
        this.initialize();
    }

    /**
     * Initialize data list
     */
    initialize(): void {
        this.data.getAll("product").then(r => { 
            this.elements = r.products;
        });
    }

    /**
     * Goto page
     */
    goToPage(page: any) {
        this.navCtrl.push(ProductDetailsPage, this.elements);
    }

    /**
     *
     */
    openItem(product: any) {
        
    }

    /**
     *
     */
    removeItem() {
        let confirm = this.alertCtrl.create({
            title: "Confirmar",
            message: "Desea borrar este producto?",
            buttons: [
                {
                    text: "Cancelar",
                    handler: () => {
                        this.toggleDelete(-1);
                    }
                },
                {
                    text: "Aceptar",
                    handler: () => {
                        let item = this.elements[this.selectedIndex];

                        this.data.delete("product", item).then(() => { 
                            
                        }).catch(() => {

                        });
                    }
                }
            ]
        });

        confirm.present();
    }
}
